From 8172e7ff04f3ed2f2bd3b18d0cd5b643ca533710 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:41:09 +0000
Subject: [PATCH 11/51] use check*() methods rather than assert


Assert statements are skipped if optimized execution is requested
(python -O), therefore they can't be used to throw exceptions for failed
checks.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index d69cb3d..109ffa1 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -81,8 +81,18 @@ class prerequisite(object):
         return fn
 
 
+class LintCheckFailed(Exception):
+    pass
+
+
 class ModuleMDLinter(object):
-    """Linter for modulemd YAML files or data."""
+    """Linter for modulemd YAML files or data.
+
+    Contains one method for each check to perform and scaffolding. The names of
+    the methods performing checks begin with 'lint_', they do nothing if the
+    check succeeds but throw a LintCheckFailed exception otherwise. An easy way
+    to do this is using the check()/check_true(), check_false() methods which
+    all accept boolean expressions."""
 
     def __init__(self, modulemd_path=None, modulemd_str=None):
         if bool(modulemd_path) == bool(modulemd_str):
@@ -135,7 +145,7 @@ class ModuleMDLinter(object):
 
             try:
                 method()
-            except Exception as e:
+            except LintCheckFailed as e:
                 try:
                     lint_detail = method.lint_detail
                 except AttributeError:
@@ -161,11 +171,26 @@ class ModuleMDLinter(object):
             if i < len(flagged) - 1:
                 print()
 
+    def check_true(self, expr):
+        """Check that a value is True or true-like."""
+        if not expr:
+            raise LintCheckFailed()
+
+    def check(self, expr):
+        """Synonym for check_true()."""
+        self.check_true(expr)
+
+    def check_false(self, expr):
+        """Check that a value is not True or true-like."""
+        self.check_true(not expr)
+
+    # lint checks below
+
     @error
     @guidelines_link('#Module_summary_and_description')
     def lint_summary_exists(self):
         """Every module MUST include a short summary."""
-        assert self.mmd.summary and self.mmd.summary.strip()
+        self.check(self.mmd.summary and self.mmd.summary.strip())
 
     @error
     @guidelines_link('#Module_summary_and_description')
@@ -173,33 +198,33 @@ class ModuleMDLinter(object):
     def lint_summary_one_sentence(self):
         """The module summary is a one sentence concise description of the
         module."""
-        assert "." not in self.mmd.summary[:-1]
+        self.check("." not in self.mmd.summary[:-1])
 
     @warning
     @guidelines_link('#Module_summary_and_description')
     @prerequisite('summary_exists')
     def lint_summary_no_trailing_period(self):
         """The summary SHOULD NOT end in a period."""
-        assert not self.mmd.summary.strip().endswith(".")
+        self.check(not self.mmd.summary.strip().endswith("."))
 
     @error
     @guidelines_link('#Module_summary_and_description')
     def lint_description_exists(self):
         """Every module MUST include a description."""
-        assert self.mmd.description and self.mmd.description.strip()
+        self.check(self.mmd.description and self.mmd.description.strip())
 
     @warning
     @guidelines_link('#Module_summary_and_description')
     @prerequisite('description_exists')
     def lint_description_ends_in_period(self):
         """The description SHOULD end in a period."""
-        assert self.mmd.description.strip().endswith(".")
+        self.check(self.mmd.description.strip().endswith("."))
 
     @error
     @guidelines_link('#Module_licensing')
     def lint_license_block_exists(self):
         """Every module MUST contain a license block."""
-        assert 'license' in self.yaml_data
+        self.check('license' in self.yaml_data)
 
     @error
     @guidelines_link('#Module_licensing')
@@ -207,7 +232,7 @@ class ModuleMDLinter(object):
     @prerequisite('license_block_exists')
     def lint_license_block_keys(self):
         """Every module MUST contain a license block."""
-        assert isinstance(self.yaml_data['license'], dict)
+        self.check(isinstance(self.yaml_data['license'], dict))
 
     @error
     @guidelines_link('#Module_licensing')
@@ -216,7 +241,7 @@ class ModuleMDLinter(object):
     def lint_license_module_block_exists(self):
         """Every module MUST contain a license block and declare a list of
         the module's licenses."""
-        assert 'module' in self.yaml_data['license']
+        self.check('module' in self.yaml_data['license'])
 
     @error
     @guidelines_link('#Module_licensing')
@@ -225,7 +250,7 @@ class ModuleMDLinter(object):
     def lint_license_module_block_is_list(self):
         """Every module MUST contain a license block and declare a list of
         the module's licenses."""
-        assert isinstance(self.yaml_data['license']['module'], list)
+        self.check(isinstance(self.yaml_data['license']['module'], list))
 
     @error
     @guidelines_link('#Module_licensing')
@@ -234,4 +259,4 @@ class ModuleMDLinter(object):
     def lint_license_content(self):
         """The packager MAY also define a list of content licenses."""
         if 'content' in self.yaml_data['license']:
-            assert isinstance(self.yaml_data['license']['content'], list)
+            self.check(isinstance(self.yaml_data['license']['content'], list))

